import { EventEmitter, TemplateRef } from '@angular/core';
import { DataTableCellEvent, DataTableColumn, DataTableParams, DataTableRow, DataTableRowEvent, DataTableTitle, DataTableTranslations, RowCallback } from '../models';
import * as i0 from "@angular/core";
export declare class DataTableStateService<T> {
    private _scheduledReload;
    private _selectAllCheckbox;
    private _sortBy;
    private _sortAsc;
    private _reloading;
    private _items;
    private _limit;
    private _offset;
    translations: DataTableTranslations;
    indexColumnVisible: boolean;
    indexColumn: boolean;
    selectColumnVisible: boolean;
    selectColumn: boolean;
    expandColumnVisible: boolean;
    expandableRows: boolean;
    selectOnRowClick: boolean;
    pagination: boolean;
    itemCount: number;
    rowTooltip: RowCallback<T> | undefined;
    title: DataTableTitle | undefined;
    rowColors: RowCallback<T> | undefined;
    rows: DataTableRow<T>[] | undefined;
    columns: DataTableColumn<T>[];
    reload: EventEmitter<DataTableParams>;
    rowExpand: EventEmitter<DataTableRowEvent<T>>;
    rowClick: EventEmitter<DataTableRowEvent<T>>;
    rowDoubleClick: EventEmitter<DataTableRowEvent<T>>;
    cellClick: EventEmitter<DataTableCellEvent<T>>;
    expandTemplate: TemplateRef<any> | undefined;
    get items(): T[];
    set items(items: T[]);
    get sortBy(): string;
    set sortBy(value: string);
    get sortAsc(): boolean;
    set sortAsc(value: boolean);
    get reloading(): boolean;
    get offset(): number;
    set offset(value: number);
    set limit(value: number);
    get limit(): number;
    get page(): number;
    set page(value: number);
    get lastPage(): number;
    reloadItems(): void;
    private buildPaginationQuery;
    private triggerReload;
    get selectAllCheckbox(): boolean;
    set selectAllCheckbox(value: boolean);
    static ɵfac: i0.ɵɵFactoryDeclaration<DataTableStateService<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<DataTableStateService<any>>;
}
